Tool: translate_query
Translates a single query into BigQuery SQL syntax.
The following code sample shows how to use curl to call the translate_query MCP tool.
| Curl Request |
|---|
curl --location 'https://bigquerymigration.googleapis.com/mcp' \ --header 'content-type: application/json' \ --header 'accept: application/json, text/event-stream' \ --data '{ "method": "tools/call", "params": { "name": "translate_query", "arguments": { // provide these details according to the tool's MCP specification } }, "jsonrpc": "2.0", "id": 1 }' |
Input Schema
Request message for TranslateQuery.
TranslateQueryRequest
| JSON representation |
|---|
{
"projectNumber": string,
"location": string,
"inputQuery": string,
"sourceDialect": string,
"metadataFilePath": string,
"translationConfigs": [
{
object ( |
| Fields | |
|---|---|
projectNumber |
Required. The Google Cloud project number. |
location |
Required. The location. For more information, see Locations. |
inputQuery |
Required. The query string to be translated. |
sourceDialect |
Required. The dialect of the source query. The following source to target dialect pairs are supported: source: Teradata, Bteq, Redshift, Oracle, HiveQL, Impala, SparkSQL, Snowflake, Netezza, AzureSynapse, Vertica, SQLServer, Presto, MySQL, Postgresql, Db2, SQLite, Greenplum, BigQuery; target: BigQuery. |
metadataFilePath |
Optional. The path to the metadata file in Cloud Storage. Format: |
translationConfigs[] |
Optional. Specifies the translation YAML configurations for this translation. For more information, see YAML configuration guidelines. |
targetDialect |
Required. The dialect of the target query. See list of supported pairs in source_dialect. |
TranslationConfig
| JSON representation |
|---|
{ "displayName": string, "content": string } |
| Fields | |
|---|---|
displayName |
Required. The display name of the configuration. Important: Name has to end with |
content |
Required. The content of the configuration. |
Output Schema
Response message for TranslateQuery.
TranslateQueryResponse
| JSON representation |
|---|
{ "translatedQuery": string, "translation": string, "translationState": string, "translationLogs": [ { object ( |
| Fields | |
|---|---|
translatedQuery |
The translated query. |
translation |
The ID of the migration workflow created for this translation. Use this ID with |
translationState |
The current state of the translation, for example, |
translationLogs[] |
A list of logs generated during the translation process. Tip: If you're using an AI client, these logs can be used to troubleshoot issues and to improve translation quality. You should persist these logs so users can see them in the UI and use them for troubleshooting or improving translation quality. |
errorInfo |
The error information. |
Log
| JSON representation |
|---|
{ "severity": string, "category": string, "message": string, "action": string, "effect": string, "impactedObject": string } |
| Fields | |
|---|---|
severity |
Severity of the translation record, for example, |
category |
Category of the error or warning, for example, |
message |
Detailed message of the record. |
action |
Recommended action to address the log. |
effect |
The effect or impact of the issue noted in the log. Effect can be one of the following values: |
impactedObject |
Name of the object that is impacted by the log message. |
ErrorInfo
| JSON representation |
|---|
{ "reason": string, "domain": string, "metadata": { string: string, ... } } |
| Fields | |
|---|---|
reason |
The reason for the error. This is a constant value that identifies the proximate cause of the error. Error reasons are unique within a particular domain of errors. This should be at most 63 characters and match a regular expression of |
domain |
The logical grouping to which the "reason" belongs. The error domain is typically the registered service name of the tool or product that generates the error. Example: "pubsub.googleapis.com". If the error is generated by some common infrastructure, the error domain must be a globally unique value that identifies the infrastructure. For Google API infrastructure, the error domain is "googleapis.com". |
metadata |
Additional structured details about this error. Keys must match a regular expression of An object containing a list of |
MetadataEntry
| JSON representation |
|---|
{ "key": string, "value": string } |
| Fields | |
|---|---|
key |
|
value |
|
Tool Annotations
Tool annotations are sent to MCP clients to describe the basic risk of a given tool. Most clients treat these hints as untrusted, but they can be used to decide when a confirmation prompt might be sent to a user.
Along with the title string, the following boolean hints are defined as follows:
readOnlyHint: If true, the tool doesn't modify its environment. Default: false.destructiveHint: If true, then the tool can perform destructive actions. If false, then the tool can only perform additive actions. Default: true.idempotentHint: If true, then calling the tool repeatedly with the same arguments will have no additional effect on its environment. Default: false.openWorldHint: If true, then the tool can interact with an 'open world' of external entities. If false, then the tool can only interact with internal entities. For example, a web search tool would be open world, while a memory tool would not be open world.
Destructive Hint: ❌ | Idempotent Hint: ❌ | Read Only Hint: ❌ | Open World Hint: ❌